#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

const int buffer_size = 1 << 3;

int main(int argc, char * argv[]) {
  if (argc != 3) return 1;
  int in_file = open(argv[1], O_RDONLY);
  int out_file = open(argv[2], O_WRONLY|O_CREAT|O_TRUNC, 0666);
  if (in_file == -1 || out_file == -1) return 2;
  char buffer[buffer_size];
  while (1) {
    ssize_t r = read(in_file, buffer, buffer_size);
    if (r == 0) break;
    ssize_t w = 0;
    while (w < r) {
      w += write(out_file, buffer + w, r - w);
    }
  }
  close(in_file);
  close(out_file);
}
