#include <fcntl.h>
#include <sys/select.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

#include <stdio.h> // for printf

const int size = 10;

int main(int argc, char * argv[]) {
  int n = argc - 1;
  char buffers[n][size];
  int files[n];
  int total = 0;
  for (int i = 1; i <= n; ++ i) files[i - 1] = open(argv[i], O_RDONLY);
  while (1) {
    int ndfs = -1;
    fd_set all;
    FD_ZERO(&all);
    for (int i = 0; i < n; ++i) if (files[i] != -1) {
      if (files[i] > ndfs) ndfs = files[i];
      FD_SET(files[i], &all);
    }
    ++ndfs;
    if (ndfs == 0) break;
    select(ndfs, &all, 0, 0, 0);
    for (int i = 0; i < n; ++i) if (FD_ISSET(files[i], &all)) {
      ssize_t r = read(files[i], buffers[i], size);
      if (r == 0) { // end of file
        close(files[i]);
        files[i] = -1;
      } else {
        total += r;
        printf("%d\n", total);
      }
    }
  }
}
