import java.util.*;

class Node {
  Node prev, next;
  int data;
}

public class Lru {
  public static void main(String[] args) {
    Scanner scan = new Scanner(System.in);
    int size = scan.nextInt();
    Node head = new Node(); head.prev = head.next = head;
    Map<Integer,Node> cache = new HashMap<>();
    int N = scan.nextInt();
    int faults = 0;
    for (int i = 0; i < N; ++i) {
      int x = scan.nextInt();
      if (!cache.containsKey(x)) {
        ++faults;
        if (cache.size() == size) {
          assert (cache.containsKey(head.prev.data));
          cache.remove(head.prev.data);
          head.prev = head.prev.prev;
          head.prev.next = head;
        }
        Node n = new Node();
        n.data = x;
        n.prev = head; n.next = head.next;
        n.prev.next = n.next.prev = n;
        cache.put(x, n);
      }
      Node n = cache.get(x); assert (n != null);
      n.prev.next = n.next; n.next.prev = n.prev;
      n.prev = head; n.next = head.next;
      n.prev.next = n.next.prev = n;
    }
    System.out.printf("%d\n",faults);
  }
}
