import java.util.*;

class Access implements Comparable<Access> {
  int reference;
  int time;
  Access(int reference, int time) {
    this.reference = reference;
    this.time = time;
  }
  public int compareTo(Access other) {
    if (time > other.time) return -1;
    if (time < other.time) return +1;
    if (reference < other.reference) return -1;
    if (reference > other.reference) return +1;
    return 0;
  }
}

public class Min {
  public static void main(String[] args) {
    Scanner scan = new Scanner(System.in);
    int capacity = scan.nextInt();
    int[] references = new int[scan.nextInt()];
    for (int i = 0; i < references.length; ++i) references[i] = scan.nextInt();
    Map<Integer, LinkedList<Integer>> times = new HashMap<>();
    for (int i = 0; i < references.length; ++i) {
      LinkedList<Integer> ts = times.get(references[i]);
      if (ts == null) {
        ts = new LinkedList<>();
        times.put(references[i], ts);
      }
      ts.addLast(i);
    }
    // TODO: binomal heap, so i can remove stuff
    PriorityQueue<Access> Q = new PriorityQueue<>();
    for (Map.Entry<Integer, LinkedList<Integer>> e : times.entrySet()) {
      Q.add(new Access(e.getKey(), e.getValue().peekFirst()));
    }
    int faults = 0;
    Set<Integer> cache = new HashSet<>();
    for (int i = 0; i < references.length; ++i) {
      LinkedList<Integer> ts = times.get(references[i]);
      ts.removeFirst();
      if (!cache.contains(references[i])) {
        ++faults;
        assert (cache.size() <= capacity);
        if (cache.size() == capacity) {
          Access access;
          do access = Q.poll(); while (!cache.contains(access.reference));
          cache.remove(access.reference);
        }
        cache.add(references[i]);
      }
      int nextTime = ts.isEmpty()? references.length : ts.peekFirst();
      Q.add(new Access(references[i], nextTime));
    }
    System.out.printf("%d\n", faults);
  }
}

