#define _POSIX_C_SOURCE 200809L
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

int main(int argc, char* argv[]) {
  if (argc != 2) return EXIT_FAILURE;
  int count; sscanf(argv[1], "%d", &count);
  int (*pipes)[2] = malloc(sizeof(int[2]) * count);
  for (int i = 0; i < count; ++i) {
    pipe(pipes[i]);
    printf("pipes %d %d\n", pipes[i][0], pipes[i][1]);
    if (fork() == 0) { // child
      close(pipes[i][0]);
      FILE * out = fdopen(pipes[i][1], "w");
      fprintf(out, "child %d\n", i);
      fflush(out);
      return EXIT_SUCCESS;
    }
  }
  close(pipes[0][1]);
  FILE * in = fdopen(pipes[0][0], "r");
  char *line;
  size_t linelen;
  while (1) {
    line = 0;
    if (getline(&line, &linelen, in) == -1) break;
    printf("got: %s\n", line);
    free(line);
  }
  for (int i = 0; i < count; ++i) wait(0);
  return EXIT_SUCCESS;
}
