#define _GNU_SOURCE
#include <sched.h>
#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>

int counter;
cpu_set_t cpu_mask;

void * thread_main(void * unused) {
  unused; // silence warning
  sched_setaffinity(0, sizeof(cpu_set_t), &cpu_mask);
  for (int i = 0; i < 100000; ++i) ++counter;
  return NULL;
}

int main(int argc, char * argv[]) {
  if (argc != 3) return EXIT_FAILURE;
  int thread_count;
  if (sscanf(argv[1], "%d", &thread_count) != 1) return EXIT_FAILURE;
  int nprocs; sscanf(argv[2], "%d", &nprocs);
  CPU_ZERO(&cpu_mask);
  for (int i = 0; i < nprocs; ++i)
    CPU_SET(i, &cpu_mask);
  pthread_t threads[thread_count];
  for (int i = 0; i < thread_count; ++i) {
    pthread_create(&threads[i], NULL, thread_main, NULL);
  }
  for (int i = 0; i < thread_count; ++i) {
    pthread_join(threads[i], NULL);
  }
  printf("%d\n", counter);
}
