#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>

pthread_mutex_t counter_mutex = PTHREAD_MUTEX_INITIALIZER;
int counter;

void * thread_main(void * unused) {
  unused; // silence warning
  pthread_mutex_lock(&counter_mutex);
  ++counter;
  pthread_mutex_unlock(&counter_mutex);
  return NULL;
}

int main(int argc, char * argv[]) {
  if (argc != 2) return EXIT_FAILURE;
  int thread_count;
  if (sscanf(argv[1], "%d", &thread_count) != 1) return EXIT_FAILURE;
  pthread_t threads[thread_count];
  for (int i = 0; i < thread_count; ++i) {
    pthread_create(&threads[i], NULL, thread_main, NULL);
  }
  for (int i = 0; i < thread_count; ++i) {
    pthread_join(threads[i], NULL);
  }
  printf("%d\n", counter);
}
